<script>
  import { onMount } from "svelte";
	import Leaves from './_design_3_leafplot.svelte';
  import { scaleLinear, scaleLog } from 'd3-scale';
  import { extent } from 'd3-array';
	import { json } from "d3-fetch";


  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const leaf_w = 230;
  const leaf_h = 90;

  let datapoints = [];
	onMount(async () => {
		datapoints = await json("/data/hourly_electricity_vs_gas_december.json");
  });
  let datav2 = {}

	$: {
			datapoints.forEach((d) => {
				if ( !(d.week in datav2)) {
					datav2[d.week] = []
				}
				if ( !(d.total_electricity in datav2[d.week])) {
				    datav2[d.week]['total_electrity'] = []
				}
				if ( !(d.total_gas in datav2[d.week])) {
				    datav2[d.week]['total_gas'] = []
				}
			})
			datapoints.forEach((d) => {
				datav2[d.week]['total_electrity'].push(d.total_electrity)
				datav2[d.week]['total_gas'].push(d.total_gas)
			})
	}

  $: rangeMin = Math.min(extent(datapoints.map((d) => d.total_electrity))[0], extent(datapoints.map((d) => d.total_gas))[0]);
	$: rangeMax = Math.max(extent(datapoints.map((d) => d.total_electrity))[1], extent(datapoints.map((d) => d.total_gas))[1]);

  $: elec_sc = scaleLinear().domain([0, rangeMax]).range([0, leaf_h])
  $: gas_sc = scaleLinear().domain([0, rangeMax]).range([ leaf_h, 0])
  $: xsc = scaleLinear().domain([0, 24*7]).range([0, leaf_w/2])

</script>

<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
  
    <line class="trunk" x1={width/2} y1={height-margin.bottom} x2={width/2} y2={margin.top+35} />
  
    {#each Object.keys(datav2) as week, week_idx}

      {#if week%2 === 0}
        <g transform="translate({width/2},{height-(leaf_h*(week_idx+2))})">
          <Leaves data={datav2[week]} {leaf_w} {leaf_h}  {xsc}{elec_sc} {gas_sc} {rangeMax} {week} />     
        </g>
      {/if}
     
      {#if week%2 === 1}
        <g transform="scale(-1, 1) translate({-1*width/2},{height-(leaf_h*(week_idx+2))})">
          <Leaves data={datav2[week]} {leaf_w} {leaf_h}  {xsc}{elec_sc} {gas_sc} {rangeMax} {week} />     
        </g>
      {/if}
	  {/each}
  </g>


</svg> 

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
  line.trunk {
    stroke: black;
    stroke-width: 2;
    stroke-opacity: 1;
  
  }
</style>
